#include "svg.h"
#include <iostream>
#include <vector>

using namespace std;

bool inbl(const int& BLOCK_WIDTH)
{
    if (BLOCK_WIDTH>30)
    {
        cerr<< "too big, please make it smaller\n";
        return false;
    }
    if (BLOCK_WIDTH<3)
    {
        cerr<< "too small, please make it bigger\n";
        return false;
    }
    return true;

}

void
svg_begin(double width, double height)
{
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_end()
{
    cout << "</svg>\n";
}

void
svg_text(double left, double baseline, string text)
{
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void svg_rect(double x, double y, double width, double height, string stroke = "black", string fill = "black")
{
    cout << "<rect x='" << x << "' y='" << y << "' width='" << width << "' height='" << height << "' stroke='" << stroke << "' fill='#" << fill << fill << fill << "' />"<<endl;
}

void
show_histogram_svg(vector<long long unsigned int> & bins)
{

    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;

    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto MAX_ASTERISK1 = 30;

    double top = 0;
    const size_t MAX_ASTERISK = IMAGE_WIDTH - TEXT_WIDTH;
    auto maxb = bins[0];

    for (size_t j = 1; j < bins.size(); j++)
    {
        if (bins[j] > maxb) maxb = bins[j];
    }


    int i = 0;

    int BLOCK_WIDTH;

    while (true){
        cerr << "block width: ";
        cin >> BLOCK_WIDTH;
        if(inbl(BLOCK_WIDTH))
            break;
    }

    auto maxb1 = maxb * BLOCK_WIDTH;

    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);

    for (size_t bin : bins)
    {

        double bin_width;

        int color = 10;

        if (maxb1 > MAX_ASTERISK)
        {
            bin_width = MAX_ASTERISK * (static_cast<double>(bin) / maxb);
        }
        else
            bin_width = BLOCK_WIDTH * bin;

        cerr << "\n" << bin_width << "\n";


        svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "violet", to_string(color));
        top += BIN_HEIGHT;
        if (i == 4)
            break;
        else
            i++;
    }

    svg_end();
}

